const int joystick_x_pin = A0; 
const int joystick_y_pin = A1;
int timer = 0;
int randNumber = 0;
int direction = 0;
int flag = 0;
String direct1;
String direct2;

/*********
  Rui Santos
  Complete project details at https://randomnerdtutorials.com  
*********/

#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels

// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, -1);

void setup() {
  Serial.begin(115200);

  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { // Address 0x3D for 128x64
    Serial.println(F("SSD1306 allocation failed"));
    for(;;);
  }
  delay(2000);
  display.clearDisplay();

  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(0, 10);
  // Display static text
  display.println("Hello, world!");
  display.display(); 
}

void loop() {
  
}


void setup() {
  Serial.begin(115200);   /* Define baud rate for serial communication */
}

void loop() {
  int x_adc_val, y_adc_val; 
  float x_volt, y_volt;
  x_adc_val = analogRead(joystick_x_pin); 
  y_adc_val = analogRead(joystick_y_pin);
  x_volt = ( ( x_adc_val * 3.3 ) / 4095 );  /*Convert digital value to voltage */
  y_volt = ( ( y_adc_val * 3.3 ) / 4095 );  /*Convert digital value to voltage */
  Serial.print("X_Voltage = ");
  Serial.print(x_volt);
  Serial.print("\t");
  Serial.print("Y_Voltage = ");
  Serial.println(y_volt);
  delay(1);
  
  if(timer == 0){
    randNumber = random(1,5);
    direction = 0;
    flag = 0;
    if(randNumber == 1){
      direct1 = "left";
    }
    else if(randNumber == 2){
      direct1 = "down";
    }
    else if(randNumber == 3){
      direct1 = "right";
    }
    else if(randNumber == 4){
      direct1 = "up";
    }
  }

  if(timer<5000){
    if(!flag){
      if(x_volt<0.3){
        direction = 3;
        direct2 = "right";
        flag = 1;
      }
      else if(x_volt>3){
        direction = 1;
        direct2 = "left";
        flag = 1;
      }
      else if(y_volt<0.3){
        direction = 2;
        direct2 = "down";
        flag = 1;
      }
      else if(y_volt>3){
        direction = 4;
        direct2 = "up";
        flag = 1;
      }
    }
    Serial.println("Simon says go " + direct1 + "! Your current direction is " + direct2 + "!");
  }

  if(timer>5000){
    if(randNumber == direction){
      Serial.println("Congrats! You got it right!");
    }
    else{
      Serial.println("Wrong! Try again!");
    }
  }

  timer++;

  if(timer>6000){
    timer = 0;
    flag = 0;
    direct1 = "neutral";
    direct2 = "neutral";
  }
}